# $Id: callback.rb,v 1.11 2000/09/24 09:55:17 toki Exp $
# --
# :
#   Хåβ
#
# 饹⥸塼:
#   module Callback
#   module Keymap
#
# ƥ饹⥸塼δط:
#   [Callback]
#     (none)
#   [Keymap]
#     (none)
#
# ƥ饹⥸塼:
#   [Callback]
#     (none)
#   [Keymap]
#     (none)
#
# ƥ饹⥸塼Υ᥽å:
#   [Callback]
#     <private method>
#       add_callback(callback_list, callback)
#       add_callback(callback_list) { ...callback... }
#       remove_callback(callback_list, callback)
#       dispatch_callback(callback_list, *args)
#   [Keymap]
#     <public method>
#       set_keymap(key, callback)
#       set_keymap(key) { ...callback... }
#       clear_keymap(key)
#       clear_all_keymap
#     <private method>
#       hook_key(key, *args)
#

module Callback
  # 1. add_callback(callback_list, callback)
  # 2. add_callback(callback_list) { ...[CALLBACK]... }
  def add_callback(callback_list, callback=nil, &block)
    if (iterator?) then
      callback_list << block
    else
      if (callback) then
	if (defined? callback.call) then
	  callback_list << callback
	else
	  for c in callback
	    callback_list << c
	  end
	end
      end
    end
  end
  private :add_callback

  def remove_callback(callback_list, callback)
    callback_list.delete(callback)
  end
  private :remove_callback

  def dispatch_callback(callback_list, *args)
    for callback in callback_list
      callback.call(*args)
    end
  end
  private :dispatch_callback
end

# [NOTE]
# 餫ᥤ󥹥ѿ @keymap 
# ϥåꤷƤɬפ롣
module Keymap
  #
  # 1. set_keymap(key, callback)
  # 2. set_keymap(key) { ...callback... }
  # -
  #  callback ά뤫 nil, false ꤹȸ
  # ϿƤ륳Хå롣
  #
  def set_keymap(key, callback=nil, &block)
    if (iterator?) then
      @keymap[key] = block
    else
      if (callback) then
	@keymap[key] = callback
      else
	@keymap.delete(key)
      end
    end
  end

  def clear_keymap(key)
    @keymap.delete(key)
  end

  def clear_all_keymap
    @keymap.clear
  end

  def hook_key(key, *args)
    if (callback = @keymap[key]) then
      callback.call(*args)
    end
  end
  private :hook_key
end
