#!/usr/local/bin/ruby
# $Id: id3tag.rb,v 1.25 1999/11/24 13:05:46 toki Exp $
# --
# :
#   MP3 ե ID3 Խ롣
#
# 饹⥸塼:
#   class OptionParser
#   module ID3Kconv
#   class ID3TagInfo
#   class Command
#   class ComplexCommand
#   class SetTagItemCommand
#   class ClearTagInfoCommand
#   class CheckMPEGFileCommand
#   class WriteTagCommand
#   class PrintTagCommand
#   class WipeCommand
#   class NoWriteCommand
#   class QuietCommand
#   class SetTagKanjiCodeCommand
#   class SetDispKanjiCodeCommand
#   class CommandFactory
#   class CommandExecution
#
# ƥ饹⥸塼δط:
#   [OptionParser]
#     (none)
#   [ID3Kconv]
#     (none)
#   [ID3TagInfo]
#     (none)
#   [Command]
#     (none)
#   [ComplexCommand]
#     <superclass>
#       Command
#   [SetTagItemCommand]
#     <superclass>
#       Command
#   [ClearTagInfoCommand]
#     <superclass>
#       ComplexCommand
#   [CheckMPEGFileCommand]
#     <superclass>
#       Command
#   [WriteTagCommand]
#     <superclass>
#       Command
#   [PrintTagCommand]
#     <superclass>
#       Command
#   [WipeCommand]
#     <superclass>
#       Command
#   [NoWriteCommand]
#     <superclass>
#       Command
#   [QuietCommand]
#     <superclass>
#       Command
#   [SetTagKanjiCodeCommand]
#     <superclass>
#       Command
#   [SetDispKanjiCodeCommand]
#     <superclass>
#       Command
#   [CommandFactory]
#     (none)
#   [CommandExecution]
#     (none)
#
# ƥ饹⥸塼:
#   [OptionParser]
#     (none)
#   [ID3Kconv]
#     TO_JIS
#     TO_EUC
#     TO_SJIS
#     NOT_CONV
#   [ID3TagInfo]
#     (none)
#   [Command]
#     (none)
#   [ComplexCommand]
#     (none)
#   [SetTagItemCommand]
#     TITLE
#     ARTIST
#     ALBUM
#     YEAR
#     COMMENT
#     GENRE
#     GENRE_NUM
#   [ClearTagInfoCommand]
#     (none)
#   [CheckMPEGFileCommand]
#     (none)
#   [WriteTagCommand]
#     (none)
#   [PrintTagCommand]
#     (none)
#   [WipeCommand]
#     (none)
#   [NoWriteCommand]
#     (none)
#   [QuietCommand]
#     (none)
#   [SetTagKanjiCodeCommand]
#     (none)
#   [SetDispKanjiCodeCommand]
#     (none)
#   [CommandFactory]
#     (none)
#   [CommandExecution]
#     (none)
#
# ƥ饹⥸塼Υ᥽å:
#   [OptionParser]
#     <class method>
#       new(args)
#     <method>
#       get_opt
#       get_opt_arg
#       each
#   [ID3Kconv]
#     <class method>
#       tag_kanji_code
#       disp_kanji_code
#       tag_kanji_code=(kcode)
#       disp_kanji_code=(kcode)
#       tag_kconv(str)
#       disp_kconv(str)
#     <private class method>
#       get_kconv(kcode)
#   [ID3TagInfo]
#     <method>
#       title
#       title=(title)
#       artist
#       artist=(artist)
#       album
#       album=(album)
#       year
#       year=(year)
#       comment
#       comment=(comment)
#       genre_num
#       genre_num=(genre_num)
#       genre=(genre)
#       write?
#       set(tag)
#   [Command]
#     <method>
#       call
#   [ComplexCommand]
#     <class method>
#       new(cmds)
#     <method>
#       call
#   [SetTagItemCommand]
#     <class method>
#       new(tag_info, item_id, item_val)
#     <method>
#       call
#   [ClearTagInfoCommand]
#     <class method>
#       new(tag_info)
#     <private method>
#       new_clear_tag_item_cmd(tag_info, item_id)
#   [CheckMPEGFileCommand]
#     <class method>
#       new(mpeg)
#     <method>
#       call
#   [WriteTagCommand]
#     <class method>
#       writable
#       writable=(writable)
#       wipe
#       wipe=(wipe)
#       new(tag_info, tag)
#     <method>
#       call
#   [PrintTagCommand]
#     <class method>
#       quiet
#       quiet=(quiet)
#       sep
#       sep=(sep)
#       new(tag, mpeg)
#     <method>
#       call
#     <private method>
#       bool(b)  
#   [WipeCommand]
#     <method>
#       call
#   [NoWriteCommand]
#     <method>
#       call
#   [QuietCommand]
#     <method>
#       call
#   [SetTagKanjiCodeCommand]
#     <class method>
#       new(kcode)
#     <method>
#       call
#   [SetDispKanjiCodeCommand]
#     <class method>
#       new(kcode)
#     <method>
#       call
#   [CommandFactory]
#     <method>
#       new_set_tag_item_cmd(tag_info, item_id, item_val)
#       new_clear_tag_info_cmd(tag_info)
#       new_check_mpeg_file_cmd(mpeg)
#       new_write_tag_cmd(tag_info, tag)
#       new_print_tag_cmd(tag, mpeg)
#       new_tag_cmd(tag_info, filename)
#       new_wipe_cmd
#       new_no_write_cmd
#       new_quiet_cmd
#       new_set_tag_kcode_cmd(kcode)
#       new_set_disp_kcode_cmd(kcode)
#     <private method>
#       new_tag(filename)
#       new_mpeg(filename)
#   [CommandExecution]
#     <class method>
#       err_count
#       err_count=(count)
#     <method>
#       add(cmd)
#       exec
#

require "kconv"
require "rmp3/mp3info"

class OptionParser
  def initialize(args)
    @args = args
    @one_letter_options = false
    @last_option = nil
  end

  def get_opt
    raise "empty" if @args.empty?
    case (@args[0])
    when /^--[^-+]+/		# long option
      @last_option = @args.shift
    when /^[-+][^-+]+/		# short option
      prefix = @args[0][0, 1]
      if (@args[0].length > 2) then
	@one_letter_options = true
	@args[0].sub!(/^#{Regexp::quote(prefix)}./, prefix)
	@last_option = $&
      else
	@one_letter_options = false
	@last_option = @args.shift
      end
    else			# filename
      @last_option = nil
      @args.shift
    end
  end

  def get_opt_arg
    unless (@last_option) then
      raise "no option"
    end
    if (@one_letter_options || @args.empty?) then
      raise "no argument: #{@last_option}"
    end
    @args.shift
  end

  def each
    until (@args.empty?)
      yield get_opt
    end
  end
end

module ID3Kconv
  TO_JIS = proc{ |str| Kconv::tojis(str) }
  TO_EUC = proc{ |str| Kconv::toeuc(str) }
  TO_SJIS = proc{ |str| Kconv::tosjis(str) }
  NOT_CONV = proc{ |str| str }

  class << self
    def get_kconv(kcode)
      case (kcode)
      when /^j/i
	TO_JIS
      when /^e/i
	TO_EUC
      when /^s/i
	TO_SJIS
      when /^n/i
	NOT_CONV
      else
	raise "unknown kanji code: #{kcode}"
      end
    end
    private :get_kconv

    attr :tag_kanji_code
    attr :disp_kanji_code

    def tag_kanji_code=(kcode)
      @tag_kconv = get_kconv(kcode)
      @tag_kanji_code = kcode
    end

    def disp_kanji_code=(kcode)
      @disp_kconv = get_kconv(kcode)
      @disp_kanji_code = kcode
    end

    def tag_kconv(str)
      @tag_kconv.call(str)
    end

    def disp_kconv(str)
      @disp_kconv.call(str)
    end
  end

  self.tag_kanji_code = $KCODE
  self.disp_kanji_code = $KCODE
end

class ID3TagInfo
  def initialize
    @title = nil
    @artist = nil
    @album = nil
    @year = nil
    @comment = nil
    @genre_num = nil
    @genre_cache = {}
  end

  attr_accessor :title
  attr_accessor :artist
  attr_accessor :album
  attr_accessor :year
  attr_accessor :comment
  attr_accessor :genre_num

  def genre=(genre)
    if (num = @genre_cache[genre]) then
      self.genre_num = num
    else
      pattern = /#{Regexp::quote(genre)}/i
      genre_list = ID3Tag::GENRE.grep(pattern)
      raise "no genre: #{genre}" if genre_list.empty?
      raise "ambiguous genre: #{genre}" if (genre_list.length > 2)
      ID3Tag::GENRE.each_index do |i|
	if (ID3Tag::GENRE[i] =~ pattern) then
	  @genre_cache[genre] = i
	  self.genre_num = i
	end
      end
    end
  end

  def write?
    @title || @artist || @album || @year || @comment || @genre_num
  end

  def set(tag)
    tag.title = ID3Kconv::tag_kconv(@title) if @title
    tag.artist = ID3Kconv::tag_kconv(@artist) if @artist
    tag.album = ID3Kconv::tag_kconv(@album) if @album
    tag.year = ID3Kconv::tag_kconv(@year) if @year
    tag.comment = ID3Kconv::tag_kconv(@comment) if @comment
    tag.genre_num = @genre_num if @genre_num
  end
end

class Command
  def call
    raise "not implemented"
  end
end

class ComplexCommand < Command
  def initialize(cmds)
    @command = cmds
  end

  def call
    for cmd in @command
      cmd.call
    end
  end
end

class SetTagItemCommand < Command
  TITLE     = "title=".intern
  ARTIST    = "artist=".intern
  ALBUM     = "album=".intern
  YEAR      = "year=".intern
  COMMENT   = "comment=".intern
  GENRE     = "genre=".intern
  GENRE_NUM = "genre_num=".intern

  def initialize(tag_info, item_id, item_val)
    @tag_info = tag_info
    @item_id = item_id
    @item_val = item_val
  end

  def call
    @tag_info.send(@item_id, @item_val)
  end
end

class ClearTagInfoCommand < ComplexCommand
  def new_clear_tag_item_cmd(tag_info, item_id)
    SetTagItemCommand::new(tag_info, item_id, nil)
  end
  private :new_clear_tag_item_cmd

  def initialize(tag_info)
    clear_cmd = [
      new_clear_tag_item_cmd(tag_info, SetTagItemCommand::TITLE),
      new_clear_tag_item_cmd(tag_info, SetTagItemCommand::ARTIST),
      new_clear_tag_item_cmd(tag_info, SetTagItemCommand::ALBUM),
      new_clear_tag_item_cmd(tag_info, SetTagItemCommand::YEAR),
      new_clear_tag_item_cmd(tag_info, SetTagItemCommand::COMMENT),
      new_clear_tag_item_cmd(tag_info, SetTagItemCommand::GENRE_NUM)
    ]
    super(*clear_cmd)
  end
end

class CheckMPEGFileCommand < Command
  def initialize(mpeg)
    @mpeg = mpeg
  end

  def call
    @mpeg.read
  end
end

class WriteTagCommand < Command
  class << self
    attr_accessor :writable
    attr_accessor :wipe
  end

  self.writable = true
  self.wipe = false

  def initialize(tag_info, tag)
    @tag_info = tag_info
    @tag = tag
  end

  def call
    if (type.wipe) then
      if (type.writable) then
	@tag.wipe
      else
	@tag.title = nil
	@tag.artist = nil
	@tag.album = nil
	@tag.year = nil
	@tag.comment = nil
	@tag.genre_num = nil
      end
    else
      @tag_info.set(@tag)
      if (type.writable) then
	@tag.write if @tag_info.write?
      end
    end
  end
end

class PrintTagCommand < Command
  class << self
    attr_accessor :quiet
    attr_accessor :sep
  end

  self.quiet = false
  self.sep = ""

  def initialize(tag, mpeg)
    @tag = tag
    @mpeg = mpeg
  end

  def bool(b)
    case (b)
    when TrueClass
      "Yes"
    when FalseClass
      "No"
    else
      raise "not boolean"
    end
  end
  private :bool

  def call
    unless (type.quiet) then
      info = [
	format("File  : %s", @tag.filename),
	format("Title : %-30s Year   : %4s", @tag.title, @tag.year),
	format("Album : %-30s Genre  : %s", @tag.album, @tag.genre),
	format("Artist: %-30s Comment: %-30s", @tag.artist, @tag.comment),
	[
	  @mpeg.version,
	  "Layer #{@mpeg.layer}",
	  "CRC(#{bool(@mpeg.error_protection)})",
	  "Copyright(#{bool(@mpeg.copyright)})",
	  "Original(#{bool(@mpeg.original)})"
	].join(", "),
	[
	  "#{@mpeg.sampling / 1000.0} kHz",
	  "#{@mpeg.bitrate} kBits/sec",
	  "#{@mpeg.mode}",
	  "#{@mpeg.file_size / 1024} KBytes",
	  "#{@mpeg.frames} frames",
	  format("%d:%02d [%d]",
		 @mpeg.minutes, @mpeg.remaining_seconds, @mpeg.seconds)
	].join(", ")
      ].join("\n")

      print type.sep
      print ID3Kconv::disp_kconv(info), "\n"
      type.sep = "\n"
    end      
  end
end

class WipeCommand < Command
  def call
    WriteTagCommand.wipe = true
  end
end

class NoWriteCommand < Command
  def call
    WriteTagCommand.writable = false
  end
end

class QuietCommand < Command
  def call
    PrintTagCommand.quiet = true
  end
end

class SetTagKanjiCodeCommand < Command
  def initialize(kcode)
    @kcode = kcode
  end

  def call
    ID3Kconv.tag_kanji_code = @kcode
  end
end

class SetDispKanjiCodeCommand < Command
  def initialize(kcode)
    @kcode = kcode
  end

  def call
    ID3Kconv.disp_kanji_code = @kcode
  end
end

class CommandFactory
  def new_tag(filename)
    ID3Tag::new(filename)
  end
  private :new_tag

  def new_mpeg(filename)
    MPEGAudioStreamFile::new(filename)
  end
  private :new_mpeg

  def new_set_tag_item_cmd(tag_info, item_id, item_val)
    SetTagItemCommand::new(tag_info, item_id, item_val)
  end

  def new_clear_tag_info_cmd(tag_info)
    ClearTagInfoCommand::new(tag_info)
  end

  def new_check_mpeg_file_cmd(mpeg)
    CheckMPEGFileCommand::new(mpeg)
  end

  def new_write_tag_cmd(tag_info, tag)
    WriteTagCommand::new(tag_info, tag)
  end

  def new_print_tag_cmd(tag, mpeg)
    PrintTagCommand::new(tag, mpeg)
  end

  def new_tag_cmd(tag_info, filename)
    tag = new_tag(filename)
    mpeg = new_mpeg(filename)
    cmd = [
      new_check_mpeg_file_cmd(mpeg),
      new_write_tag_cmd(tag_info, tag),
      new_print_tag_cmd(tag, mpeg)
    ]
    ComplexCommand::new(cmd)
  end

  def new_wipe_cmd
    WipeCommand::new
  end

  def new_no_write_cmd
    NoWriteCommand::new
  end

  def new_quiet_cmd
    QuietCommand::new
  end

  def new_set_tag_kcode_cmd(kcode)
    SetTagKanjiCodeCommand::new(kcode)
  end

  def new_set_disp_kcode_cmd(kcode)
    SetDispKanjiCodeCommand::new(kcode)
  end
end

class CommandExecution
  class << self
    attr_accessor :err_count
  end

  self.err_count = 0

  def initialize
    @command = []
  end

  def add(cmd)
    @command.push(cmd)
  end

  def exec
    for cmd in @command
      begin
	cmd.call
      rescue NotMPEGAudioStreamFileError
	type.err_count += 1
	print $!, "\n"
      end
    end
  end
end

if (ARGV.empty?) then
  print [
    "usage: #{File::basename($0)} [options 1] [mp3 file 1] [options 2] [mp3 file 2] ...",
    "<options>",
    "  -t, --title [title]",
    "  +t, --no-title",
    "  -a, --artist [artist]",
    "  +a, --no-artist",
    "  -l, --album [album]",
    "  +l, --no-album",
    "  -y, --year [year]",
    "  +y, --no-year",
    "  -c, --comment [comment]",
    "  +c, --no-comment",
    "  -g, --genre [genre]",
    "  -n, --genre-num [genre number]",
    "  +g, +n, --no-genre",
    "  -x, --clear",
    "  -w, --wipe",
    "  -d, --no-write",
    "  -q, --quiet",
    "  -j, --tag-kanji [ID3 TAG kanji code: jis, euc, sjis, no_kanji]",
    "  -k, --disp-kanji [display kanji code: jis, euc, sjis, no_kanji]"
  ].join("\n") + "\n"
  exit
end

TITLE     = SetTagItemCommand::TITLE
ARTIST    = SetTagItemCommand::ARTIST
ALBUM     = SetTagItemCommand::ALBUM
YEAR      = SetTagItemCommand::YEAR
COMMENT   = SetTagItemCommand::COMMENT
GENRE     = SetTagItemCommand::GENRE
GENRE_NUM = SetTagItemCommand::GENRE_NUM

tag_info = ID3TagInfo::new
cmd_factory = CommandFactory::new
global_cmd = CommandExecution::new
local_cmd = CommandExecution::new

options = OptionParser::new(ARGV)
for opt in options
  case (opt)
  when "-t", "--title"
    local_cmd.add \
      cmd_factory.new_set_tag_item_cmd(tag_info, TITLE, options.get_opt_arg)
  when "+t", "--no-title"
    local_cmd.add \
      cmd_factory.new_set_tag_item_cmd(tag_info, TITLE, nil)
  when "-a", "--artist"
    local_cmd.add \
      cmd_factory.new_set_tag_item_cmd(tag_info, ARTIST, options.get_opt_arg)
  when "+a", "--no-artist"
    local_cmd.add \
      cmd_factory.new_set_tag_item_cmd(tag_info, ARTIST, nil)
  when "-l", "--album"
    local_cmd.add \
      cmd_factory.new_set_tag_item_cmd(tag_info, ALBUM, options.get_opt_arg)
  when "+l", "--no-album"
    local_cmd.add \
      cmd_factory.new_set_tag_item_cmd(tag_info, ALBUM, nil)
  when "-y", "--year"
    local_cmd.add \
      cmd_factory.new_set_tag_item_cmd(tag_info, YEAR, options.get_opt_arg)
  when "+y", "--no-year"
    local_cmd.add \
      cmd_factory.new_set_tag_item_cmd(tag_info, YEAR, nil)
  when "-c", "--comment"
    local_cmd.add \
      cmd_factory.new_set_tag_item_cmd(tag_info, COMMENT, options.get_opt_arg)
  when "+c", "--no-comment"
    local_cmd.add \
      cmd_factory.new_set_tag_item_cmd(tag_info, COMMETN, nil)
  when "-g", "--genre"
    local_cmd.add \
      cmd_factory.new_set_tag_item_cmd(tag_info, GENRE, options.get_opt_arg)
  when "-n", "--genre-num"
    local_cmd.add \
      cmd_factory.new_set_tag_item_cmd(tag_info, GENRE_NUM, options.get_opt_arg.to_i)
  when "+g", "+n", "--no-genre"
    local_cmd.add \
      cmd_factory.new_set_tag_item_cmd(tag_info, GENRE_NUM, nil)
  when "-x", "--clear"
    local_cmd.add cmd_factory.new_clear_tag_info_cmd(tag_info)
  when "-w", "--wipe"
    local_cmd.add cmd_factory.new_wipe_cmd
  when "-d", "--no-write"
    global_cmd.add cmd_factory.new_no_write_cmd
  when "-q", "--quiet"
    global_cmd.add cmd_factory.new_quiet_cmd
  when "-j", "--tag-kanji"
    local_cmd.add cmd_factory.new_set_tag_kcode_cmd(options.get_opt_arg)
  when "-k", "--disp-kanji"
    global_cmd.add cmd_factory.new_set_disp_kcode_cmd(options.get_opt_arg)
  else
    if (opt =~ /^[-+]/) then
      raise "wrong options: #{opt}"
    else
      filename = opt
      local_cmd.add cmd_factory.new_tag_cmd(tag_info, filename)
    end
  end
end

global_cmd.exec
local_cmd.exec

if (CommandExecution.err_count > 0) then
  exit 1
else
  exit 0
end
