#!/usr/local/bin/ruby
# $Id: rmp3.rb,v 1.165 2001/06/17 01:25:45 toki Exp $
# --
# :
#   MP3 ץ졼䡼
#
# 饹⥸塼:
#   module RMP3
#   module RMP3::Kconv
#   module RMP3::Config
#   class RMP3::Application
#   class RMP3::Loader
#   class RMP3::SimpleLoader
#   class RMP3::TTYLoader
#   class RMP3::X11Loader
#   class RMP3::Option
#
# ƥ饹⥸塼δط:
#   [RMP3]
#     <include>
#       RMP3::Config
#   [RMP3::Kconv]
#     (none)
#   [RMP3::Config]
#     (none)
#   [RMP3::Application]
#     <include>
#       Callback (callback.rb)
#   [RMP3::Loader]
#     <include>
#       RMP3::Config
#   [RMP3::SimpleLoader]
#     <superclass>
#       RMP3::Loader
#   [RMP3::TTYLoader]
#     <superclass>
#       RMP3::Loader
#   [RMP3::X11Loader]
#     <superclass>
#       RMP3::Loader
#   [RMP3::Option]
#     <include>
#       Enumerable
#
# ƥ饹⥸塼:
#   [RMP3]
#     RCS_ID
#     VERSION
#     DATE
#     LOADER
#     INTERFACE
#     RCFILE
#   [RMP3::Kconv]
#     (none)
#   [RMP3::Config]
#     <property>
#       CONFIG
#     <group name>
#       RMP3
#     <attribute name>
#       OPT_HELP
#       OPT_VERSION
#       OPT_INTERFACE
#       OPT_REPEAT
#       OPT_SHUFFLE
#       OPT_PLAYLIST
#       OPT_MPG123_OPTIONS
#       OPT_DISP_KCODE
#       OPT_TAG_KCODE
#       OPTION_HOOK
#       MP3_INFO_CALLBACK
#       MPG123_INFO_CALLBACK
#       PREPLAY_CALLBACK
#       PLAYING_CALLBACK
#       POSTPLAY_CALLBACK
#   [RMP3::Application]
#     (none)
#   [RMP3::Loader]
#     (none)
#   [RMP3::SimpleLoader]
#     (none)
#   [RMP3::TTYLoader]
#     (none)
#   [RMP3::X11Loader]
#     (none)
#   [RMP3::Option]
#     (none)
#
# ƥ饹⥸塼Υ᥽å:
#   [RMP3]
#     <module function>
#       has_loader?(name)
#       has_interface?(name) [alias of has_loader?]
#       add_loader(loader)
#       remove_loader(name)
#       get_loader(name=nil)
#       print_help
#       print_version
#       init_kconv
#       get_playlist(args)
#       parse_options(args)
#       start(args)
#   [RMP3::Kconv]
#     <class method>
#       init(kconv)
#     <module function>
#       kconv(str)
#   [RMP3::Config]
#     (none)
#   [RMP3::Application]
#     <class method>
#       new(play_list, mpg123_opts=nil)
#     <public method>
#       player
#       repeat
#       repeat=(repeat)
#       shuffle
#       shuffle=(shuffle)
#       playing?
#       start
#       init
#       final
#       add_init_callback(callback)
#       add_init_callback { |app| ... }
#       add_final_callback(callback)
#       add_final_callback { |app| ... }
#       remove_init_callback(callback)
#       remove_final_callback(callback)
#     <private method>
#       dispatch_init_callback
#       dispatch_final_callback
#   [RMP3::Loader]
#     <class method>
#       new(name)
#     <public method>
#       name
#       loadable? [abstract]
#       start(app) [abstract]
#       load(app)
#     <private method>
#       setup(app)
#   [RMP3::SimpleLoader]
#     <public method>
#       loadable?
#   [RMP3::TTYLoader]
#     <public method>
#       loadable?
#   [RMP3::X11Loader]
#     <public method>
#       loadable?
#   [RMP3::Option]
#     <class method>
#       new(args)
#     <public method>
#       get_opt
#       get_opt_arg
#       each
#
# URL:
#   http://www.freedom.ne.jp/toki/ruby/rmp3-1.1d.tar.gz
#

require "kconv"
require "thread"
require "rmp3/mp3"
require "rmp3/callback"
require "rmp3/property"

Thread.abort_on_exception = true

module RMP3
  RCS_ID  = %q$Id: rmp3.rb,v 1.165 2001/06/17 01:25:45 toki Exp $
  VERSION = "1.1e"
  DATE    = "2001-02-08"

  module Kconv
    class << self
      def init(kconv)
	@kconv = kconv
      end

      def kconv(str)
	@kconv.call(str)
      end
    end

    def kconv(str)
      Kconv::kconv(str)
    end
    private :kconv
  end

  module Config
    CONFIG = Property::new

    #### group ####

    RMP3 = "rmp3"
    CONFIG.add_group(RMP3)


    #### attribute ####

    OPT_HELP           = "option.help"
    OPT_VERSION        = "option.version"
    OPT_INTERFACE      = "option.interface"
    OPT_REPEAT         = "option.repeat"
    OPT_SHUFFLE        = "option.shuffle"
    OPT_PLAYLIST       = "option.playlist"
    OPT_MPG123_OPTIONS = "option.mpg123-options"
    OPT_DISP_KCODE     = "option.display-kanji-code"
    OPT_TAG_KCODE      = "option.mpeg-file-kanji-code"
    OPTION_HOOK        = "option-hook"

    INIT_CALLBACK        = "callback.initialization"
    FINAL_CALLBACK       = "callback.finalization"
    MP3_INFO_CALLBACK    = "callback.mp3-info"
    MPG123_INFO_CALLBACK = "callback.mpg123-info"
    PREPLAY_CALLBACK     = "callback.preplay"
    PLAYING_CALLBACK     = "callback.playing"
    POSTPLAY_CALLBACK    = "callback.postplay"


    #### default settings ####

    CONFIG[RMP3, OPT_HELP]           = false
    CONFIG[RMP3, OPT_VERSION]        = false
    CONFIG[RMP3, OPT_INTERFACE]      = false
    CONFIG[RMP3, OPT_SHUFFLE]        = false
    CONFIG[RMP3, OPT_PLAYLIST]       = []
    CONFIG[RMP3, OPT_MPG123_OPTIONS] = false
    CONFIG[RMP3, OPT_DISP_KCODE]     = $KCODE
    CONFIG[RMP3, OPT_TAG_KCODE]      = $KCODE

    CONFIG[RMP3, OPTION_HOOK] = [
      # [ [<option list>],
      #   <option hook>,
      #   <option argument description or nil>
      # ], ...
      [ %w[ -h --help ],
	proc{ CONFIG[RMP3, OPT_HELP] = true },
	nil
      ],
      [ %w[ +h --no-help ],
	proc{ CONFIG[RMP3, OPT_HELP] = false },
	nil
      ],
      [ %w[ -v --version ],
	proc{ CONFIG[RMP3, OPT_VERSION] = true },
	nil
      ],
      [ %w[ +v --no-version ],
	proc{ CONFIG[RMP3, OPT_VERSION] = false },
	nil
      ],
      [ %w[ -i --interface ],
	proc{ |arg| CONFIG[RMP3, OPT_INTERFACE] = arg },
	proc{ "[" + INTERFACE.keys.sort.join(', ') + "]" }
      ],
      [ %w[ +i --no-interface ],
	proc{ CONFIG[RMP3, OPT_INTERFACE] = false },
	nil
      ],
      [ %w[ -r --repeat ],
	proc{ CONFIG[RMP3, OPT_REPEAT] = true },
	nil
      ],
      [ %w[ +r --no-repeat ],
	proc{ CONFIG[RMP3, OPT_REPEAT] = false },
	nil
      ],
      [ %w[ -z --shuffle ],
	proc{ CONFIG[RMP3, OPT_SHUFFLE] = true },
	nil
      ],
      [ %w[ +z --no-shuffle ],
	proc{ CONFIG[RMP3, OPT_SHUFFLE] = false },
	nil
      ],
      [ %w[ -f --playlist ],
	proc{ |arg| CONFIG[RMP3, OPT_PLAYLIST] << arg },
	"[playlist file]"
      ],
      [ %w[ +f --no-playlist ],
	proc{ CONFIG[RMP3, OPT_PLAYLIST].clear },
	nil
      ],
      [ %w[ -m --mpg123-options ],
	proc{ |arg|
	  if (CONFIG[RMP3, OPT_MPG123_OPTIONS]) then
	    CONFIG[RMP3, OPT_MPG123_OPTIONS] << " " + arg
	  else
	    CONFIG[RMP3, OPT_MPG123_OPTIONS] = arg
	  end
	},
	"[mpg123 options]"
      ],
      [ %w[ +m --no-mpg123-options ],
	proc{ CONFIG[RMP3, OPT_MPG123_OPTIONS] = false },
	nil
      ],
      [ %w[ -k --display-kanji-code ],
	proc{ |arg| CONFIG[RMP3, OPT_DISP_KCODE] = arg },
	"[jis, euc, sjis, none]"
      ],
      [ %w[ -j --tag-kanji-code ],
	proc{ |arg| CONFIG[RMP3, OPT_TAG_KCODE] = arg },
	"[jis, euc, sjis, none]"
      ]
    ]
  end
  include Config

  class Application
    include Callback

    def initialize(play_list, mpg123_opts=nil, kcode=$KCODE)
      @player = MP3Player::new(mpg123_opts, kcode)
      @player.list = play_list
      @shuffle = false

      @init_callback = []
      @final_callback = []

      @player.add_preplay_callback do |player|
	if (@shuffle) then
	  (player.list.length - 1).times do |i|
	    j = i + rand(player.list.length - i)
	    player.list[i], player.list[j] = player.list[j], player.list[i]
	  end
	end
      end
      srand
    end

    attr :player

    def repeat
      @player.repeat
    end

    def repeat=(repeat)
      @player.repeat = repeat
    end

    attr_accessor :shuffle

    def playing?
      @player.playing?
    end

    def start
      @player.play
    end

    def init
      dispatch_init_callback
    end

    def final
      dispatch_final_callback
    end

    #
    # 1. add_init_callback(callbacl)
    # 2. add_init_callback { |app| ...callback... }
    # -
    # callback ϼΥ᥽åɤɬפ롣
    #   callback.call(app)
    #
    def add_init_callback(callback=nil, &block)
      add_callback(@init_callback, callback, &block)
    end

    #
    # 1. add_final_callback(callbacl)
    # 2. add_final_callback { |app| ...callback... }
    # -
    # callback ϼΥ᥽åɤɬפ롣
    #   callback.call(app)
    #
    def add_final_callback(callback=nil, &block)
      add_callback(@final_callback, callback, &block)
    end

    def remove_init_callback(callback)
      remove_callback(@init_callback, callback)
    end

    def remove_final_callback(callback)
      remove_callback(@final_callback, callback)
    end

    def dispatch_init_callback
      dispatch_callback(@init_callback, self)
    end
    private :dispatch_init_callback

    def dispatch_final_callback
      dispatch_callback(@final_callback, self)
    end
    private :dispatch_final_callback
  end

  class Loader
    include Config

    def initialize(name)
      @name = name
    end

    attr :name

    def loadable?
      raise NotImplementError, "#{type}\#lodable? is not implemented."
    end

    def setup(app)
      app.add_init_callback(CONFIG[@name, INIT_CALLBACK])
      app.add_final_callback(CONFIG[@name, FINAL_CALLBACK])
      app.player.add_mp3_info_callback(CONFIG[@name, MP3_INFO_CALLBACK])
      app.player.add_mpg123_info_callback(CONFIG[@name, MPG123_INFO_CALLBACK])
      app.player.add_preplay_callback(CONFIG[@name, PREPLAY_CALLBACK])
      app.player.add_playing_callback(CONFIG[@name, PLAYING_CALLBACK])
      app.player.add_postplay_callback(CONFIG[@name, POSTPLAY_CALLBACK])
    end
    private :setup

    def start(app)
      raise NotImplementError, "#{type}\#start is not implemented."
    end

    def load(app)
      setup(app)
      app.init
      begin
	start(app)
      ensure
	app.final
      end
    end
  end

  class SimpleLoader < Loader
    def loadable?
      true
    end
  end

  class TTYLoader < Loader
    def loadable?
      STDIN.tty? && STDOUT.tty? && ! (ENV["TERM"] =~ /dumb|unknown/i)
    end
  end

  class X11Loader < Loader
    def loadable?
      ENV["DISPLAY"]
    end
  end

  class Option
    include Enumerable

    def initialize(args)
      @args = args
      @end_of_parse = false
      @one_letter_options = false
      @last_option = nil
    end

    def get_opt
      if (! @end_of_parse) then
	case (@args[0])
	when /^--$/		# explicit end of options
	  @args.shift
	  @end_of_parse = true
	  nil
	when /^--[^-+].*/	# long option
	  @last_option = @args.shift
	when /^[-+][^-+]+/	# short option
	  prefix = @args[0][0, 1]
	  if (@args[0].length > 2) then
	    @one_letter_options = true
	    @args[0].sub!(/^#{Regexp::quote(prefix)}./, prefix)
	    @last_option = $&
	  else
	    @one_letter_options = false
	    @last_option = @args.shift
	  end
	else			# end of options
	  @end_of_parse = true
	  nil
	end
      end
    end

    def get_opt_arg
      if (@one_letter_options || @end_of_parse) then
	raise "no argument (option: #{@last_option})"
      end
      @args.shift
    end

    def each
      while (name = get_opt)
	yield name
      end
    end
  end

  LOADER = []
  INTERFACE = {}
  RCFILE = File::join(ENV["HOME"], ".#{File::basename(__FILE__, '.rb')}rc")

  def has_loader?(name)
    INTERFACE.has_key? name
  end
  module_function :has_loader?

  alias has_interface? has_loader?

  def add_loader(loader)
    unless (has_loader? loader.name) then
      LOADER << loader
      INTERFACE[loader.name] = loader
    else
      raise "already have a loader: #{loader.name}"
    end
  end
  module_function :add_loader

  def remove_loader(name)
    if (has_loader?) then
      loader = INTERFACE[name]
      INTERFACE.delete(name)
      LOADER.delete(loader)
      loader
    else
      raise "not found a loader: #{name}"
    end
  end
  module_function :remove_loader

  def get_loader(name=nil)
    if (name) then
      loader = INTERFACE[name]
      unless (loader) then
	raise "unknown interface: #{name}"
      end
      unless (loader.loadable?) then
	raise "can't load interface: #{name}"
      end
      loader
    else
      LOADER.reverse_each do |loader|
	if (loader.loadable?) then
	  return loader
	end
      end
      raise "not found loadable interface."
    end
  end
  module_function :get_loader

  def print_help
    print "usage: #{File::basename($0)} [options] [MP3 files]\n"
    print "<options>\n"
    for opts, hook, arg in CONFIG[RMP3, OPTION_HOOK]
      print "  ", opts.join(", ")
      if (arg) then
	print " "
	if (defined? arg.call) then
	  print arg.call
	else
	  print arg
	end
      end
      print "\n"
    end
    print "<startup file>\n"
    print "  ~/#{File::basename(RCFILE)}\n"
    exit
  end
  module_function :print_help

  def print_version
    print "Ruby MP3 player (by Yoshinori Toki <toki@freedom.ne.jp>)\n"
    print "version #{VERSION} (#{DATE})\n"
    exit unless CONFIG[RMP3, OPT_HELP]
  end
  module_function :print_version

  def init_kconv
    case (CONFIG[RMP3, OPT_DISP_KCODE])
    when /^j/i
      Kconv::init(proc{ |str| ::Kconv::tojis(str) })
    when /^e/i
      Kconv::init(proc{ |str| ::Kconv::toeuc(str) })
    when /^s/i
      Kconv::init(proc{ |str| ::Kconv::tosjis(str) })
    else
      Kconv::init(proc{ |str| str })
    end
  end
  module_function :init_kconv

  def get_playlist(args)
    playlist = []
    def playlist.read(stream)
      for line in stream
	mp3 = line.sub(/(^|\s)\#.*$/, '').strip
	next if mp3.empty?
	self << mp3
      end
    end
    for src in CONFIG[RMP3, OPT_PLAYLIST]
      if (src.kind_of? String) then
	filename = src
	if (filename == "-") then
	  playlist.read(STDIN)
	else
	  File::open(filename) do |file|
	    playlist.read(file)
	  end
	end
      else
	for mp3 in src
	  unless (mp3.kind_of? String) then
	    raise "failed to convert #{mp3.type} to String: #{mp3.inspect}"
	  end
	  playlist << mp3
	end
      end
    end
    unless (args.empty?) then
      for mp3 in args
	playlist << mp3
      end
    end
    if (playlist.empty?) then
      raise "empty playlist"
    end
    playlist
  end
  module_function :get_playlist

  def parse_options(args)
    opt_hook = {}
    for opts, hook, has_arg in CONFIG[RMP3, OPTION_HOOK]
      for opt in opts
	opt_hook[opt] = [ hook, has_arg ]
      end
    end

    options = Option::new(args)
    for opt in options
      hook, has_arg = opt_hook[opt]
      if (hook) then
	if (has_arg) then
	  hook.call(options.get_opt_arg)
	else
	  hook.call
	end
      else
	raise "unknown option: #{opt}"
      end
    end

    if (CONFIG[RMP3, OPT_VERSION]) then
      print_version
    end
    if (CONFIG[RMP3, OPT_HELP] || (CONFIG[RMP3, OPT_PLAYLIST].empty? && ARGV.empty?)) then
      print_help
    end
    init_kconv
  end
  module_function :parse_options

  def start(args)
    app = Application::new(get_playlist(args),
			   CONFIG[RMP3, OPT_MPG123_OPTIONS],
			   CONFIG[RMP3, OPT_TAG_KCODE])
    app.repeat = CONFIG[RMP3, OPT_REPEAT]
    app.shuffle = CONFIG[RMP3, OPT_SHUFFLE]
    loader = get_loader(CONFIG[RMP3, OPT_INTERFACE])
    loader.load(app)
  end
  module_function :start
end


################ Startup ################

# default interfaces
require "rmp3/dumb"
require "rmp3/curses"

# startup file
if (File::file? RMP3::RCFILE) then
  load(RMP3::RCFILE)
end

RMP3::parse_options(ARGV)
RMP3::start(ARGV)
